//*****************************************************************************
// File:        MainFrm.pas
//
// Classe:      TForm1
//
// Description: TForm1 is the main form of the application.
//
// Note:
//
//*****************************************************************************
// Last version: 2006-10-02
//*****************************************************************************

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Math,
  OpenGL,
  Tetra,
  Point,
  Triangle,
  Vector,
  GeomTools,
  InOut,
  Isosurface,
  PartitionSurface,
  Crust,
  DrawTools,
  Mesh,
  Menus,
  AddPtFrm,
  RandomFrm,
  InterpolateFrm,
  RandomSphereFrm,
  CrossvalidationFrm,
  SetupViewFrm,
  GridFrm,
  AboutFrm,
  OpenGLForm, OpenGLScene, OpenGLCamera, OpenGLLight, OpenGLTypes,
  OpenGLManipulator, OpenGLManipulatorForObjects, CheckLst;

type
  TForm1 = class(TGLForm)
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    FileMenu: TMenuItem;
    HelpMenu: TMenuItem;
    HelpAboutMenu: TMenuItem;
    FileOpenMenu: TMenuItem;
    FileSavePtsMenu: TMenuItem;
    FileQuitMenu: TMenuItem;
    OpenDialog1: TOpenDialog;
    FileSaveTopoMenu: TMenuItem;
    N1: TMenuItem;
    FileCloseMenu: TMenuItem;
    N2: TMenuItem;
    InsertMenu: TMenuItem;
    InsertRandomMenu: TMenuItem;
    InsertRandomSphereMenu: TMenuItem;
    InsertGridMenu: TMenuItem;
    Panel2: TPanel;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    CheckBox4: TCheckBox;
    UpDown1: TUpDown;
    Edit7: TEdit;
    Label7: TLabel;
    ViewMenu: TMenuItem;
    ViewAxesMenu: TMenuItem;
    N3: TMenuItem;
    ViewResetMenu: TMenuItem;
    CheckBox5: TCheckBox;
    MiscMenu: TMenuItem;
    MiscInvariantsMenu: TMenuItem;
    MiscNoTetraMenu: TMenuItem;
    MiscNoPtsMenu: TMenuItem;
    InsertOnePtMenu: TMenuItem;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    CheckBox3: TCheckBox;
    CheckBox7: TCheckBox;
    GroupBox4: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    CheckBox8: TCheckBox;
    MiscOptimMenu: TMenuItem;
    Label2: TLabel;
    CheckBox9: TCheckBox;
    ComboBox2: TComboBox;
    ToolsMenu: TMenuItem;
    ToolsPartitionMenu: TMenuItem;
    N4: TMenuItem;
    ViewSetupMenu: TMenuItem;
    ToolsCrustMenu: TMenuItem;
    CheckBox10: TCheckBox;
    GroupBox5: TGroupBox;
    Button2: TButton;
    Button4: TButton;
    MiscAvgDegree: TMenuItem;
    Button1: TButton;
    Edit3: TEdit;
    InsertPower1: TMenuItem;
    ToolsIdentifySliversMenu: TMenuItem;
    InterpolateMenu: TMenuItem;
    InterpolatePtMenu: TMenuItem;
    InterpolateCrossvalidationMenu: TMenuItem;
    TestingMenu: TMenuItem;
    TestingInterpolateMenu: TMenuItem;
    TestingInsertDeleteGridEarMenu: TMenuItem;
    TestingDeleteInsertAllMenu: TMenuItem;
    TestingInsertDeleteGridPowerMenu: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    InsertRegularSphereMenu: TMenuItem;
    N7: TMenuItem;
    TestingDeleteAllRandomly_insphereMenu: TMenuItem;
    TestingDeleteAllRandomly_powerMenu: TMenuItem;
    TestingDeleteAllRandomlyDLimitMenu: TMenuItem;
    TestingDeleteInsertPoint: TMenuItem;
    TestingDeleteNNMenu: TMenuItem;
    MiscMinMaxDegreeMenu: TMenuItem;
    N8: TMenuItem;
    GroupBox6: TGroupBox;
    Label9: TLabel;
    GroupBox7: TGroupBox;
    CheckBox12: TCheckBox;
    Edit8: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Edit9: TEdit;
    Label12: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Edit10: TEdit;
    N9: TMenuItem;
    TestingInterpolateInsertMenu: TMenuItem;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    MenuInsertRandomCube: TMenuItem;
    Randompoints1: TMenuItem;
    MiscNbPtsCH: TMenuItem;
    MiscJamesStuff: TMenuItem;
    N10: TMenuItem;
    MiscVolumeRatio: TMenuItem;
    GroupBox8: TGroupBox;
    CheckListBox1: TCheckListBox;
    CheckBox15: TCheckBox;
    CheckBox17: TCheckBox;
    Label3: TLabel;
    Button3: TButton;
    CheckBox14: TCheckBox;
    GroupBox9: TGroupBox;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    CheckBox16: TCheckBox;
    Label21: TLabel;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    CheckBox6: TCheckBox;
    Edit11: TEdit;
    Edit12: TEdit;
    CheckBox13: TCheckBox;
    Label13: TLabel;
    Label14: TLabel;
    GroupBox10: TGroupBox;
    CheckBox18: TCheckBox;
    Button5: TButton;
    MiscHLPtInfo: TMenuItem;
    N11: TMenuItem;
    MiscVolumeVoronoiCell: TMenuItem;
    MiscIsOnCH: TMenuItem;
    TestingDelete10percent: TMenuItem;
    CheckBox11: TCheckBox;
    CheckBox19: TCheckBox;
    procedure MenuFileQuitClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure FileQuitMenuClick(Sender: TObject);
    procedure FileOpenMenuClick(Sender: TObject);
    procedure FileSaveTopoMenuClick(Sender: TObject);
    procedure FileSavePtsMenuClick(Sender: TObject);
    procedure FileCloseMenuClick(Sender: TObject);
    procedure InsertRandomMenuClick(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure InsertRandomSphereMenuClick(Sender: TObject);
    procedure InsertGridMenuClick(Sender: TObject);
    procedure FormActivate(Sender: TObject); override;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer); override;
    procedure CheckBox4Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure ViewAxesMenuClick(Sender: TObject);
    procedure ViewResetMenuClick(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure MiscInvariantsMenuClick(Sender: TObject);
    procedure MiscNoTetraMenuClick(Sender: TObject);
    procedure MiscNoPtsMenuClick(Sender: TObject);
    procedure InsertOnePtMenuClick(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SetOpenGLInitialProperties; override;
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure MiscOptimMenuClick(Sender: TObject);
    procedure ComboBox2DropDown(Sender: TObject);
    procedure ComboBox2Select(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure ToolsPartitionMenuClick(Sender: TObject);
    procedure ViewSetupMenuClick(Sender: TObject);

    function  getGLScene : TGLScene;
    procedure ToolsCrustMenuClick(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HelpAboutMenuClick(Sender: TObject);

    procedure Button2Click(Sender: TObject);
    procedure Refresh;
    procedure Button4Click(Sender: TObject);
    procedure MiscAvgDegreeClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure InsertPower1Click(Sender: TObject);
    procedure ToolsIdentifySliversMenuClick(Sender: TObject);
    procedure InterpolatePtMenuClick(Sender: TObject);
    procedure InterpolateCrossvalidationMenuClick(Sender: TObject);
    procedure TestingInterpolateMenuClick(Sender: TObject);
    procedure TestingInsertDeleteGridEarMenuClick(Sender: TObject);
    procedure TestingInsertDeleteGridPowerMenuClick(Sender: TObject);
    procedure TestingDeleteInsertAllMenuClick(Sender: TObject);
    procedure InsertRegularSphereMenuClick(Sender: TObject);
    procedure TestingDeleteAllRandomly_insphereMenuClick(Sender: TObject);
    procedure TestingDeleteAllRandomly_powerMenuClick(Sender: TObject);
    procedure TestingDeleteAllRandomlyDLimitMenuClick(Sender: TObject);
    procedure TestingDeleteInsertPointClick(Sender: TObject);
    procedure TestingDeleteNNMenuClick(Sender: TObject);
    procedure MiscMinMaxDegreeMenuClick(Sender: TObject);
    procedure Edit8Change(Sender: TObject);
    procedure CheckBox12Click(Sender: TObject);
    procedure Edit9Exit(Sender: TObject);
    procedure TestingInterpolateInsertMenuClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure TestInterpolationNN(step: integer);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure MenuInsertRandomCubeClick(Sender: TObject);
    procedure MiscNbPtsCHClick(Sender: TObject);
    procedure MiscVolumeRatioClick(Sender: TObject);
    procedure CheckBox15Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox16Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox13Click(Sender: TObject);
    procedure CheckBox18Click(Sender: TObject);
    procedure MiscVolumeVoronoiCellClick(Sender: TObject);
    procedure MiscIsOnCHClick(Sender: TObject);
    procedure TestingDelete10percentClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    m_mesh: TMesh;
    m_axes: TGLAxes;
    procedure CreateBigTetra;
  public
    function  StampTime : double;
  end;

var
  Form1: TForm1;


implementation



{$R *.DFM}


procedure TForm1.CreateBigTetra;
var
  pt0: TPoint;
  pt1: TPoint;
  pt2: TPoint;
  pt3: TPoint;
  bb0: TPoint;
  bb1: TPoint;
begin
  //-- points for the big tetra
{  pt0 := TPoint.Create(-100, -100, -100);
  pt1 := TPoint.Create(-100, 1000, -100);
  pt2 := TPoint.Create(1000, -100, -100);
  pt3 := TPoint.Create(-100, -100, 1000);
}
  pt0 := TPoint.Create(-101, -102, -101);
  pt1 := TPoint.Create(-99, 1004, -106);
  pt2 := TPoint.Create(1002, -98, -103);
  pt3 := TPoint.Create(-104, -97, 1003);

{  pt0 := TPoint.Create(-90.19, -90.96, -90.37);
  pt1 := TPoint.Create(-90.99, 990.96, -90.68);
  pt2 := TPoint.Create(990.22, -90.24, -90.14);
  pt3 := TPoint.Create(-100.58, -100.21, 1000.02);
}
  //-- points for the bounding box (for the insertion)
  bb0 := TPoint.Create(0, 0, 0);
  bb1 := TPoint.Create(1, 1, 1);
  m_mesh := TMesh.Create(pt0, pt1, pt2, pt3, bb0, bb1);
  pt0.Free;
  pt1.Free;
  pt2.Free;
  pt3.Free;
  bb0.Free;
  bb1.Free;
end;


procedure TForm1.MenuFileQuitClick(Sender: TObject);
begin
  Self.Close;
end;


//******************************************************************************
// Description: Display/hide delaunay triangulation
//
// Input:       -
//
// Output:      -
//******************************************************************************
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  m_mesh.bDrawDelaunay := not m_mesh.bDrawDelaunay;
  FormPaint(self);
end;
         

//******************************************************************************
// Description: Display/hide voronoi cells
//
// Input:       -
//
// Output:      -
//******************************************************************************
procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  m_mesh.bDrawVoronoi := not m_mesh.bDrawVoronoi;
  FormPaint(self);
end;

procedure TForm1.FileQuitMenuClick(Sender: TObject);
begin
  Form1.Close;
end;


procedure TForm1.FileOpenMenuClick(Sender: TObject);
var
  name: string;
  f: TextFile;
  io: TMesh_IO;
  startTime, endTime: double;
begin
  Form1.OpenDialog1.Filter := 'Points Files (*.pts)|*.pts';
  if OpenDialog1.Execute then
  begin
    name := OpenDialog1.FileName;
    AssignFile(f, name);
    Reset(f);
    try
      io := TMesh_IO.Create(m_mesh);
      startTime := self.StampTime;
      io.ReadPoints(f);
      endTime := self.StampTime;
//      ShowMessage('total time = ' + FloatToStr(endTime - startTime));
      io.Free;
      m_mesh.BuildDisplayList;
    finally
      CloseFile(F);
    end;
    FormPaint(self);
  end;
end;


procedure TForm1.FileSaveTopoMenuClick(Sender: TObject);
var
  name: string;
  f: TextFile;
  io: TMesh_IO;
begin
  Form1.SaveDialog1.Filter := 'Text files (*.txt)|*.txt';
  Form1.SaveDialog1.DefaultExt := 'txt';
  if SaveDialog1.Execute then
  begin
    name := SaveDialog1.FileName;
    AssignFile(f, name);
    Rewrite(f);
    try
      io := TMesh_IO.Create(m_mesh);
      io.SaveTopology(f);
      io.Free;
    finally
      CloseFile(f);
    end;
  end;
  FormPaint(self);
end;


procedure TForm1.FileSavePtsMenuClick(Sender: TObject);
var
  name: string;
  f: TextFile;
  io: TMesh_IO;
begin
  Form1.SaveDialog1.Filter := 'Points files (*.pts)|*.pts';
  Form1.SaveDialog1.DefaultExt := 'txt';
  if SaveDialog1.Execute then
  begin
    name := SaveDialog1.FileName;
    AssignFile(f, name);
    Rewrite(f);
    try
      io := TMesh_IO.Create(m_mesh);
      io.SavePoints(f);
      io.Free;
    finally
      CloseFile(f);
    end;
  end;
  FormPaint(self);
end;


procedure TForm1.FileCloseMenuClick(Sender: TObject);
begin
  FreeAndNil(m_mesh);
  CreateBigTetra;
  GLScene.SetTerrain(m_mesh);
  //-- translate coord checkbox
  GLScene.getManipulator.SetRotationCenter(0, 0, 0);
  self.CheckBox5.Checked := false;
  //-- delaunay/voronoi/points display
  m_mesh.BuildDisplayList;
  m_mesh.bDrawDelaunay := self.CheckBox1.Checked;
  m_mesh.bDrawVoronoi := self.CheckBox2.Checked;
  m_mesh.bDrawPoints := self.CheckBox7.Checked;
  //-- desactivate the HL display
  self.CheckBox3.Checked := false;
  self.CheckBox3Click(self);
  self.CheckBox4.Checked := false;
  self.CheckBox4Click(self);
  self.CheckBox12.Checked := false;
  self.CheckBox12Click(self);
  self.CheckBox15.Checked := false;
  self.CheckBox15Click(self);
  self.CheckBox17.Checked := false;

  FormPaint(self);
end;


procedure TForm1.InsertRandomMenuClick(Sender: TObject);
var
  i: integer;
  nb: integer;
  startTime, endTime: double;
  x, y, z: double;
begin
  RandomFrm.Form2.Caption := 'Random points';
  if (RandomFrm.Form2.ShowModal = mrOk) then
  begin
    nb := StrToInt(RandomFrm.Form2.Edit1.Text);
    ProgressBar1.Min := 0;
    ProgressBar1.Max := nb;
    ProgressBar1.Step := 1;
    Randomize;
    startTime := self.StampTime;
    for i := 1 to nb do
    begin
      m_mesh.InsertPoint(Random, Random, Random, Random * 5);
      ProgressBar1.StepIt;
    end;
    endTime := self.StampTime;
//    ShowMessage('total time = ' + FloatToStr(endTime - startTime));
  end;
  m_mesh.BuildDisplayList;
  FormPaint(self);
//  ShowMessage('no drawing.');
  ProgressBar1.Position := 0;
end;



//******************************************************************************
// Description: highlight a voronoi cell
//
// Input:       -
//
// Output:      -
//******************************************************************************
procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  if (CheckBox3.Checked = true) then
  begin
    m_mesh.bHLVertex := true;
    ComboBox1.Enabled := true;
    CheckBox13.Enabled := true;
    CheckBox6.Enabled := true;
  end
  else
  begin
    m_mesh.bHLVertex := false;
    ComboBox1.Clear;
    ComboBox1.Enabled := false;
    GLScene.getManipulator.SetRotationCenter(0.5, 0.5, 0.5);
    CheckBox13.Enabled := false;
    CheckBox6.Enabled := false;
    CheckBox18.Checked := false;
    CheckBox18Click(nil);
    FormPaint(self);
  end;
end;


//******************************************************************************
// Description: Create random points on a sphere, those points are not equally
//              distributed
//
// Input:       -
//
// Output:      (the points are added to the mesh)
//******************************************************************************
procedure TForm1.InsertRandomSphereMenuClick(Sender: TObject);
var
  i: integer;
  nb: integer;
  radius: double;
  center: TPoint;
  t: TVector;
  normT: double;
  perturb: double;
  delta: double;
begin
  if (RandomSphereFrm.Form3.ShowModal = mrOk) then
  begin
    nb := StrToInt(RandomSphereFrm.Form3.Edit1.Text);
    ProgressBar1.Min := 0;
    ProgressBar1.Max := nb;
    ProgressBar1.Step := 1;
    radius := StrToFloat(RandomSphereFrm.Form3.Edit2.Text);
    center := TPoint.Create(StrToFloat(RandomSphereFrm.Form3.Edit3.Text),
                            StrToFloat(RandomSphereFrm.Form3.Edit4.Text),
                            StrToFloat(RandomSphereFrm.Form3.Edit5.Text));
    perturb := StrToFloat(RandomSphereFrm.Form3.Edit6.Text);
    t := TVector.Create;
    Randomize;
    for i := 1 to nb do
    begin
      t.coord.x := -(Random * radius * 2) + radius;
      t.coord.y := -(Random * radius * 2) + radius;
      t.coord.z := -(Random * radius * 2) + radius;
      normT := t.GetLength;
      if (perturb <> 0) then
      begin
        delta := -(Random * perturb * 2) + perturb;
        t.Multiply((radius + delta) / normT);
      end
      else
      begin
        t.Multiply(radius / normT);
      end;
      m_mesh.InsertPoint(t.coord.x + center.x, t.coord.y + center.y,
                         t.coord.z + center.z, Random * 5);
      ProgressBar1.StepIt;
    end;
    t.Free;
    center.Free;
  end;
  m_mesh.BuildDisplayList;
  FormPaint(self);
  ProgressBar1.Position := 0;
end;


procedure TForm1.InsertRegularSphereMenuClick(Sender: TObject);
var
  x, y, z: double;
  theta, phi: double;
  d: double;
  i: integer;
  r: double;
begin
  r := 0.4;
  theta := 0;
  phi := 0;
  d := Pi / 5; //-- define 'density'
  while (theta < (2 * Pi)) do
  begin
    phi := 0;
    while phi < pi do
    begin
      x := 0.5 + (r * cos(theta) * sin(phi));
      y := 0.5 + (r * sin(theta) * sin(phi));
      z := 0.5 + (r * cos(phi));
      phi := phi + d;
      try
        m_mesh.InsertPoint(x, y, z);
      except
        on E: Exception do
      end;
    end;
    theta := theta + d;
  end;
  m_mesh.BuildDisplayList;
  FormPaint(self);
end;


//******************************************************************************
// Description: Create a "grid" in 3d
//
// Input:       -
//
// Output:      (the points are added to the mesh)
//******************************************************************************
procedure TForm1.InsertGridMenuClick(Sender: TObject);
var
  numX, numY, numZ: integer;
  xMin, yMin: double;
  xMax, yMax: double;
  zMin, zMax: double;
  i: integer;
  j: integer;
  k: integer;
  spaceX: double;
  spaceY: double;
  spaceZ: double;
  delta: double;
  perturb: TVector;
  startTime, endTime: double;
begin
  if (GridFrm.Form4.ShowModal = mrOk) then
  begin
    numX := StrToInt(GridFrm.Form4.Edit1.Text);
    numY := StrToInt(GridFrm.Form4.Edit2.Text);
    numZ := StrToInt(GridFrm.Form4.Edit3.Text);
    xMin := StrToFloat(GridFrm.Form4.Edit4.Text);
    yMin := StrToFloat(GridFrm.Form4.Edit5.Text);
    xMax := StrToFloat(GridFrm.Form4.Edit6.Text);
    yMax := StrToFloat(GridFrm.Form4.Edit7.Text);
    zMin := StrToFloat(GridFrm.Form4.Edit8.Text);
    zMax := StrToFloat(GridFrm.Form4.Edit9.Text);
    delta := StrToFloat(GridFrm.Form4.Edit10.Text);

    spaceX := (xMax - xMin) / numX;
    spaceY := (yMax - yMin) / numY;
    if (numZ <> 0) then
      spaceZ := (zMax - zMin) / numZ
    else
      spaceZ := 0;

    ProgressBar1.Min := 0;
    ProgressBar1.Max := (numx + 1) * (numy + 1) * (numz + 1);
    ProgressBar1.Step := 1;
    perturb := TVector.Create;
    Randomize;
    startTime := self.StampTime;
    for i := 0 to numX do
    begin
      for j := 0 to numY do
      begin
        for k := 0 to numZ do
        begin
          if (delta <> 0) then
          begin
            perturb.coord.x := -(Random * delta * 2) + delta;
            perturb.coord.y := -(Random * delta * 2) + delta;
            perturb.coord.z := -(Random * delta * 2) + delta;
            try
              perturb.Normalize;
              perturb.Multiply(delta);
              m_mesh.InsertPoint(xMin + (i * spaceX) + perturb.coord.x,
                                 yMin + (j * spaceY) + perturb.coord.y,
                                 zMin + (k * spaceZ) + perturb.coord.z);
            except
              on E: EZeroDivide do
              begin
                m_mesh.InsertPoint(xMin + (i * spaceX), yMin + (j * spaceY), zMin + (k * spaceZ), Random * 5);
              end;
            end;
          end
          else
            m_mesh.InsertPoint(xMin + (i * spaceX), yMin + (j * spaceY), zMin + (k * spaceZ), Random * 5);
          ProgressBar1.StepIt;
        end;
      end;
    end;
    endTime := self.StampTime;
//    ShowMessage('total time = ' + FloatToStr(endTime - startTime));
    perturb.Free;
  end;
  m_mesh.BuildDisplayList;
  FormPaint(self);
  ProgressBar1.Position := 0;
end;


procedure TForm1.FormActivate(Sender: TObject);
var
  light: TGLLight;
  manipulator: TGLManipulator;
  i: integer;
begin
  //-- initialize the mesh
  CreateBigTetra;
  //example with drawing on panel
  GLScene := TGLScene.Create(self.Handle, self, self);
  try
    GLScene.Initialize;
  except
    on E: Exception do
    begin
      ShowMessage('Error during OpenGL initialization: '+ E.Message);
      GLScene.Destroy;
      Application.Terminate;
    end;
  end;
  GLScene.SetTerrain(m_mesh);
  //create manipulator and pass it into after initializing GLScene
  manipulator := TGLManipulatorForObjects.Create(self, self);
  //set initial opengl properties
  SetOpenGLInitialProperties;
  //set camera initial properties
//  GLScene.getCamera.SetPosition(0, 0, 20, 0, 0, 0, 0, 1, 0);
  GLScene.getCamera.SetPosition(0, 0, 8, 0, 0, 0, 0, 1, 0);
  GLScene.getCamera.SetShape(60, 1, 0.1, 35); //camera.SetShape(60, 1, 0.1, 25);
  //set gaps before manipulator
  GLScene.SetGaps(0, 0, Panel2.Width, 0);
  GLScene.SetManipulator(manipulator);
  light := TGLLight.Create;
  light.setAmbient(0.1, 0.1, 0.1, 1);
  light.setDiffuse(0.7, 0.7, 0.7, 1);
  light.setPosition(-5, 5, 100, 1);
  GLScene.AddLight(light);
  light := TGLLight.Create;
  light.setAmbient(0.1, 0.1, 0.1, 1);
  light.setDiffuse(0.7, 0.7, 0.7, 1);
  light.setPosition(10, 0, 50, 1);
  GLScene.AddLight(light);
  light := TGLLight.Create;
  light.setAmbient(0.1, 0.1, 0.1, 1);
  light.setDiffuse(0.7, 0.7, 0.7, 1);
  light.setPosition(0, 0, 50, 1);
  GLScene.AddLight(light);
  GLScene.TurnAllLights(true);
  m_axes := TGLAxes.Create;
  GLScene.AddObject(m_axes);
  m_axes.SetEnabled(false);

  m_mesh.bDrawDelaunay := self.CheckBox1.Checked;
  m_mesh.bDrawVoronoi := self.CheckBox2.Checked;
  m_mesh.bDrawPoints := self.CheckBox7.Checked;
  m_mesh.BuildDisplayList;
  //-- set the center of rotation at (.5, .5, .5)
  GLScene.getManipulator.SetRotationCenter(0.5, 0.5, 0.5);

  //-- geology slices
  for i := 1 to 9 do
  begin
    CheckListBox1.AddItem(IntToStr(i), nil);
  end;
end;


{ TODO : example of picking objects }
procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//var
//  res: TGLEventResult;
begin
  inherited;
{  res := GLScene.OnMouseDown(Sender, Button, Shift, X, Y);
  if  res = glerRepaintNeeded then
    self.FormPaint(self)
  else if res = glerNotHandled then
  begin
    ShowMessage('allo');
  end;
  }
end;


//******************************************************************************
// Description: highlight a tetra
//
// Input:       -
//
// Output:      -
//******************************************************************************
procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  if (CheckBox4.Checked = true) then
  begin
    m_mesh.bHLTetra := true;
    m_mesh.SetHLTetra(StrToFloat(Edit4.Text),
                    StrToFloat(Edit5.Text),
                    StrToFloat(Edit6.Text),
                    StrToInt(Edit7.Text), CheckBox10.Checked);
    self.CheckBox5.Checked := true;
    self.CheckBox5Click(self);
  end
  else
  begin
    m_mesh.bHLTetra := false;
    //-- put the rotation center at (0, 0, 0)
    self.CheckBox5.Checked := false;
    self.CheckBox5Click(self);
  end;
  FormPaint(self);
end;


procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  inherited;

  if (m_mesh.bHLTetra = true) then
  begin
    m_mesh.SetHLTetra(StrToFloat(Edit4.Text),
                    StrToFloat(Edit5.Text),
                    StrToFloat(Edit6.Text),
                    StrToInt(Edit7.Text), CheckBox10.Checked);
  end;
  FormPaint(self);
end;


procedure TForm1.ViewAxesMenuClick(Sender: TObject);
begin
  if (ViewAxesMenu.Checked = true) then
  begin
    ViewAxesMenu.Checked := false;
    m_axes.SetEnabled(false);
  end
  else
  begin
    ViewAxesMenu.Checked := true;
    m_axes.SetEnabled(true);
  end;
  FormPaint(self);
end;

procedure TForm1.ViewResetMenuClick(Sender: TObject);
begin
  inherited;
  GLScene.Reset;
//  mesh.BuildDisplayList;
  if (ViewAxesMenu.Checked = true) then
    m_axes.SetEnabled(true)
  else
    m_axes.SetEnabled(false);

  FormPaint(self);
end;

//******************************************************************************
// Description: translate coord after a tetra is HL
//
// Input:       -
//
// Output:      -
//******************************************************************************
procedure TForm1.CheckBox5Click(Sender: TObject);
var
  pt: TPoint;
begin
  if (CheckBox5.Checked = true) then
  begin
    pt := m_mesh.GetTempPt;
    GLScene.getManipulator.SetRotationCenter(pt.x, pt.y, pt.z);
  end
  else
  begin
    GLScene.getManipulator.SetRotationCenter(0.5, 0.5, 0.5);
  end;
  FormPaint(self);
end;


procedure TForm1.MiscInvariantsMenuClick(Sender: TObject);
begin
  try
    m_mesh.TestInvariants;
    ShowMessage('Invariants are OK');
  except
    on E: Exception do
    begin
      ShowMessage(E.Message);
    end;
  end;
end;


procedure TForm1.MiscNoTetraMenuClick(Sender: TObject);
begin
  ShowMessage(IntToStr(m_mesh.GetListTetra.Count));
end;


procedure TForm1.MiscNoPtsMenuClick(Sender: TObject);
begin
  ShowMessage(IntToStr(m_mesh.GetNbPts));
end;


procedure TForm1.InsertOnePtMenuClick(Sender: TObject);
begin
  if (AddPtFrm.Form5.ShowModal = mrOk) then
  begin
    try
      m_mesh.InsertPoint(StrToFloat(AddPtFrm.Form5.Edit1.Text),
                         StrToFloat(AddPtFrm.Form5.Edit2.Text),
                         StrToFloat(AddPtFrm.Form5.Edit3.Text),
                         StrToFloat(AddPtFrm.Form5.Edit4.Text));
      m_mesh.BuildDisplayList;
    except
      on E: Exception do
      begin
        ShowMessage(E.Message);
      end;
    end;
  end;
  FormPaint(self);
end;


procedure TForm1.ComboBox1DropDown(Sender: TObject);
var
  i: integer;
  tempt: TPoint;
begin
  //-- update the element in the combobox
  ComboBox1.Clear;
  //-- cannot draw the voronoi cell one of the bounding box point
  //-- so cannot select the first 4 points in the list
  for i := 4 to (m_mesh.GetNbPts - 1) do
  begin
    ComboBox1.AddItem(IntToStr(i - 3), m_mesh.GetListPts[i]);
  end;
end;


procedure TForm1.ComboBox1Select(Sender: TObject);
var
  i: integer;
  pt: TPoint;
begin
  i := ComboBox1.ItemIndex;
  if (i <> -1) then
  begin
    pt := TPoint(ComboBox1.Items.Objects[i]);
    m_mesh.SetHLVertex(pt, CheckBox6.Checked, CheckBox13.Checked);
    GLScene.getManipulator.SetRotationCenter(pt.x, pt.y, pt.z);
    Edit11.Text := IntToStr(m_mesh.GetNbEdgeInStar(pt));
    Edit12.Text := IntToStr(m_mesh.GetNbTetraInStar(pt));
    if (CheckBox18.Checked = true) then
      CheckBox18Click(nil);
    FormPaint(self);
  end;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  m_mesh.Free;
  m_axes.Free;
  inherited;
end;


procedure TForm1.SetOpenGLInitialProperties;
var
  ambientLight: TLightParameters;
begin
  glEnable(GL_DEPTH_TEST);
  // enabling hiding the back surfaces
  // glEnable(GL_CULL_FACE);
  // glCullFace(GL_BACK);
  // enabling smooth shade model
  glShadeModel(GL_SMOOTH);
  // enable lighting
  glEnable(GL_LIGHTING);
  // enable material properties
  glEnable(GL_COLOR_MATERIAL);

  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  //set additional ambient light in the scene
//{
  ambientLight.r := 0.5;
  ambientLight.g := 0.5;
  ambientLight.b := 0.5;
  ambientLight.a := 1.0;
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @ambientLight);
//}
end;


procedure TForm1.CheckBox7Click(Sender: TObject);
begin
  m_mesh.bDrawPoints := not m_mesh.bDrawPoints;
  FormPaint(self);
end;


procedure TForm1.CheckBox8Click(Sender: TObject);
var
  iso: TIsosurface;
begin
  if (CheckBox8.Checked = true) then
  begin
    iso := TIsosurface.Create(m_mesh);
    m_mesh.bDrawIso := true;
    iso.DrawIsosurface(StrToFloat(self.Edit1.Text));
    FreeAndNil(iso);
  end
  else
  begin
    m_mesh.bDrawIso := false;
  end;
  FormPaint(self);
end;


procedure TForm1.MiscOptimMenuClick(Sender: TObject);
begin
  if (MiscOptimMenu.Checked = true) then
  begin
    MiscOptimMenu.Checked := false;
    m_mesh.bOptim := false;
  end
  else
  begin
    MiscOptimMenu.Checked := true;
    m_mesh.bOptim := true;
  end;
end;

procedure TForm1.ComboBox2DropDown(Sender: TObject);
var
  i: integer;
  te: TTetra;
begin
  //-- update the element in the combobox
  ComboBox2.Clear;
  //-- cannot draw the voronoi cell one of the bounding box point
  //-- so cannot select the first 4 points in the list
  for i := 0 to (m_mesh.GetListTetra.Count - 1) do
  begin
    te := m_mesh.GetListTetra[i];
    ComboBox2.AddItem(IntToStr(te.m_no), te);
  end;
end;


procedure TForm1.ComboBox2Select(Sender: TObject);
var
  i: integer;
  te: TTetra;
begin
  i := ComboBox2.ItemIndex;
  if (i <> -1) then
  begin
    te := TTetra(ComboBox2.Items.Objects[i]);
    m_mesh.SetHLTetra(te, CheckBox10.Checked);
    FormPaint(self);
  end;
end;


procedure TForm1.CheckBox9Click(Sender: TObject);
begin
  if (CheckBox9.Checked = true) then
  begin
    m_mesh.bHLTetra := true;
    ComboBox2.Enabled := true;
  end
  else
  begin
    m_mesh.bHLTetra := false;
    ComboBox2.Enabled := false;
    FormPaint(self);
  end;
end;


procedure TForm1.ToolsPartitionMenuClick(Sender: TObject);
var
  split: TPartitionSurface;
begin
  if (ToolsPartitionMenu.Checked = true) then
  begin
    split := TPartitionSurface.Create(m_mesh);
    split.DrawPartitionSurface;
    FreeAndNil(split);
  end
  else
  begin
    m_mesh.bDrawPartition := false;
  end;
  FormPaint(self);
end;


procedure TForm1.ViewSetupMenuClick(Sender: TObject);
begin
  if (SetupViewFrm.Form6.ShowModal = mrOk) then
  begin
    //-- size of the nodes
    TDrawTools.SetNodeRadius(StrToFloat(SetupViewFrm.Form6.Edit1.Text) / 1000);
    if (m_mesh.bHLVertex = true) then
    begin
      m_mesh.SetHLVertex(m_mesh.GetHLPt, false, false);
    end;
    if (m_mesh.bHLTetra = true) then
    begin
      if (self.CheckBox4.Checked = true) then
      begin
        m_mesh.SetHLTetra(StrToFloat(Edit4.Text),
                          StrToFloat(Edit5.Text),
                          StrToFloat(Edit6.Text),
                          StrToInt(Edit7.Text), CheckBox10.Checked);
      end
      else
      begin
        if (CheckBox9.Checked = true) then
        begin
          ComboBox2Select(nil);
        end;
      end;
    end;
    //-- background color (black or white)
    if (SetupViewFrm.Form6.RadioButton1.Checked = true) then
    begin
      glClearColor(0.0, 0.0, 0.0, 0.0);
    end
    else
    begin
      glClearColor(1.0, 1.0, 1.0, 0.0);
    end;
    //-- draw or not only the convex hull of the dataset
    if (SetupViewFrm.Form6.DrawCHBox.Checked = true) then
      m_mesh.bDrawCHOnly := true
    else
      m_mesh.bDrawCHOnly := false;

    //-- draw or not the triangular faces of the CH
    if (SetupViewFrm.Form6.DrawFacesCH.Checked = true) then
      m_mesh.bDrawCHFaces := true
    else
      m_mesh.bDrawCHFaces := false;

    //-- HL the vertices on CH of dataset
    if (SetupViewFrm.Form6.DrawHLPtsOnCH.Checked = true) then
      m_mesh.bDrawPtsOnCH := true
    else
      m_mesh.bDrawPtsOnCH := false;
  end;
  m_mesh.BuildDisplayList;
  FormPaint(self);
end;


function TForm1.getGLScene: TGLScene;
begin
  Result := self.GLScene;
end;


procedure TForm1.ToolsCrustMenuClick(Sender: TObject);
var
  c: TCrust;
begin
  if (ToolsCrustMenu.Checked = true) then
  begin
    c := TCrust.Create(m_mesh);
    c.ExtractCrust;
    FreeAndNil(c);
  end
  else
  begin
    m_mesh.bDrawCrust := false;
  end;
  FormPaint(self);
end;


procedure TForm1.CheckBox10Click(Sender: TObject);
begin
  if (m_mesh.bHLTetra = true) then
  begin
    if (self.CheckBox4.Checked = true) then
    begin
      m_mesh.SetHLTetra(StrToFloat(Edit4.Text),
                        StrToFloat(Edit5.Text),
                        StrToFloat(Edit6.Text),
                        StrToInt(Edit7.Text), CheckBox10.Checked);
    end
    else
    begin
      if (CheckBox9.Checked = true) then
      begin
        ComboBox2Select(nil);
      end;
    end;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
{$IFDEF FLOAT}
  self.Caption := self.Caption + '   [float]';
{$ELSEIF True}
  self.Caption := self.Caption + '   [robust]';
{$IFEND}

{$IFDEF DEBUG}
  self.Caption := self.Caption + '   [debug mode]';
{$ENDIF}

{$IFDEF PERTURB}
  self.Caption := self.Caption + '   [perturbation]';
{$ENDIF}
end;


procedure TForm1.HelpAboutMenuClick(Sender: TObject);
begin
  AboutFrm.AboutBox.ShowModal;
end;



//******************************************************************************
// Description: Delete the highlighted point in the mesh with the tetra method
//
// Input:       - (the HL point is retrieved from the combobox list
//
// Output:      - (point is deleted)
//******************************************************************************
procedure TForm1.Button2Click(Sender: TObject);
var
  i: integer;
  pt: TPoint;
begin
  i := ComboBox1.ItemIndex;
  if (i <> -1) then
  begin
    pt := TPoint(ComboBox1.Items.Objects[i]);
    m_mesh.DeleteVertex_tetra(pt);
    m_mesh.BuildDisplayList;
    FormPaint(self);
  end
  else
  begin
    ShowMessage('You must first select a vertex.');
  end;
end;


procedure TForm1.Refresh;
begin
  FormPaint(self);
end;


//******************************************************************************
// Description: Delete the highlighted point in the mesh with the ear method
//
// Input:       - (the HL point is retrieved from the combobox list
//
// Output:      - (point is deleted)
//******************************************************************************
procedure TForm1.Button4Click(Sender: TObject);
var
  i: integer;
  pt: TPoint;
begin
  i := ComboBox1.ItemIndex;
  if (i <> -1) then
  begin
    pt := TPoint(ComboBox1.Items.Objects[i]);
    CheckBox3.Checked := false;
    CheckBox3Click(nil);
    CheckBox18.Checked := false;
    CheckBox18Click(nil);
    m_mesh.DeleteVertex_insphere(pt, CheckBox11.Checked);
    m_mesh.BuildDisplayList;
    FormPaint(self);
  end
  else
  begin
    ShowMessage('You must first select a vertex.');
  end;
end;


procedure TForm1.MiscAvgDegreeClick(Sender: TObject);
begin
  ShowMessage(FloatToStrF(m_mesh.GetAvgDegree, ffGeneral, 5, 1));
end; 


procedure TForm1.Button1Click(Sender: TObject);
var
  i: integer;
  pt: TPoint;
begin
  i := ComboBox1.ItemIndex;
  if (i <> -1) then
  begin
    pt := TPoint(ComboBox1.Items.Objects[i]);
    m_mesh.DeleteVertex_power__2(pt, false);
    m_mesh.BuildDisplayList;
    FormPaint(self);
  end
  else
  begin
    ShowMessage('You must first select a vertex.');
  end;
end;


procedure TForm1.InsertPower1Click(Sender: TObject);
begin
  if (AddPtFrm.Form5.ShowModal = mrOk) then
  begin
    try
      m_mesh.InsertPoint_power(StrToFloat(AddPtFrm.Form5.Edit1.Text),
                               StrToFloat(AddPtFrm.Form5.Edit2.Text),
                               StrToFloat(AddPtFrm.Form5.Edit3.Text),
                               StrToFloat(AddPtFrm.Form5.Edit4.Text));
      m_mesh.BuildDisplayList;
    except
      on E: Exception do
      begin
        ShowMessage(E.Message);
      end;
    end;
  end;
  FormPaint(self);
end;


//******************************************************************************
// Description: Identify the 'worst' sliver in the mesh (the one with the
//              smallest volume).
//
// Input:       -
//
// Output:      - (the worst sliver becomes the HL tetra in the mesh, and its
//                 volume and vertices are given).
//******************************************************************************

procedure TForm1.ToolsIdentifySliversMenuClick(Sender: TObject);
var
  lstTe: TList;
  i: integer;
  te, sliver: TTetra;
  minvol, vol: double;
begin
  if (ToolsIdentifySliversMenu.Checked = true) then
  begin
    ToolsIdentifySliversMenu.Checked := false;
    m_mesh.bHLTetra := false;
  end
  else
  begin
    ToolsIdentifySliversMenu.Checked := true;
    m_mesh.bHLTetra := true;
    minvol := 9999;
    sliver := nil;
    te := nil;
    lstTe := m_mesh.GetListTetra;
    for i := 0 to (lstTe.Count - 1) do
    begin
      te := lstTe[i];
      vol := te.GetVolume;
      if (vol < minvol) then
      begin
        minvol := vol;
        sliver := te;
      end;
    end;
    ShowMessage(FloatToStr(minvol));
    ShowMessage(IntToStr(te.GetP(1).m_no) + '   ' + IntToStr(te.GetP(2).m_no) + '   ' + IntToStr(te.GetP(3).m_no) + '   ' + IntToStr(te.GetP(4).m_no));
    //-- HL the tetra
    m_mesh.bHLTetra := true;
    m_mesh.SetHLTetra(te, false);
  end;
  FormPaint(self);
end;

     
procedure TForm1.InterpolatePtMenuClick(Sender: TObject);
var
  estimate: double;
  radius: double;
  x, y, z: double;
  startTime, endTime: double;
begin
  if (InterpolateFrm.Form7.ShowModal = mrOk) then
  begin
    estimate := 0;
    x := StrToFloat(InterpolateFrm.Form7.Edit1.Text);
    y := StrToFloat(InterpolateFrm.Form7.Edit2.Text);
    z := StrToFloat(InterpolateFrm.Form7.Edit3.Text);
    startTime := self.StampTime;
    try
      if (InterpolateFrm.Form7.RadioButton1.Checked = true) then
        estimate := m_mesh.Interpolate_linear(x, y, z)
      else if (InterpolateFrm.Form7.RadioButton2.Checked = true) then
        estimate := m_mesh.Interpolate_nn(x, y, z)
      else if (InterpolateFrm.Form7.RadioButton4.Checked = true) then
        estimate := m_mesh.Interpolate_nearest(x, y, z)
      else if (InterpolateFrm.Form7.RadioButton3.Checked = true) then
      begin
        radius := StrToFloat(InterpolateFrm.Form7.Edit4.Text);
        estimate := m_mesh.Interpolate_idw(x, y, z, radius);
      end;
    except
      on E: Exception do
      begin
        ShowMessage(E.Message);
      end;
    end;
    endTime := self.StampTime;
    ShowMessage('Value =  ' + FloatToStr(estimate));
    ShowMessage(FloatToStr(endTime - startTime));
  end;
end;


procedure TForm1.InterpolateCrossvalidationMenuClick(Sender: TObject);
var
  real: array of double;
  estim: array of double;
  ff: TextFile;
  i: integer;
begin
  if (CrossvalidationFrm.Form8.ShowModal = mrOk) then
  begin
    ProgressBar1.Min := 0;
    ProgressBar1.Max := m_mesh.GetNbPts;
    ProgressBar1.Step := 1;

    SetLength(real, m_mesh.GetNbPts - 4);
    SetLength(estim, m_mesh.GetNbPts - 4);
    try
      if (CrossvalidationFrm.Form8.RadioButton1.Checked = true) then
        m_mesh.CrossValidation(1, real, estim)
      else if (CrossvalidationFrm.Form8.RadioButton2.Checked = true) then
        m_mesh.CrossValidation(2, real, estim)
      else if (CrossvalidationFrm.Form8.RadioButton3.Checked = true) then
        m_mesh.CrossValidation(3, real, estim);

      ProgressBar1.Position := 0;
      AssignFile(ff, 'd:\Tetra Robust\cross.txt');
      Rewrite(ff);
      for i := 0 to (m_mesh.GetNbPts - 5) do
      begin
        Write(ff, FloatToStrF(real[i], fffixed, 15, 15) + #9);
        WriteLn(ff, FloatToStrF(estim[i], fffixed, 15, 15));
      end;
      CloseFile(ff);
    except
      on E: Exception do
      begin
        ShowMessage(E.Message);
      end;
    end;
  end;
  ShowMessage('done.');
end;


//******************************************************************************
// Description: Testing an interpolation method. Starting from a dataset, the
//              interpolation process is performed at many different locations
//              (at the nodes of a 3D grid).
//
// Input:       -
//
// Output:      the test is performed, if nothing went wrong it says 'done.'
//******************************************************************************
procedure TForm1.TestingInterpolateMenuClick(Sender: TObject);
var
  i, j, k: integer;
  tempt: TPoint;
  n: integer;
  low, high: integer;
  int: double;
begin
  low := 0;
  high := 5;
  int := 0.2;
  n := 0;
  for i := low to high do
  begin
    for j := low to high do
    begin
      for k := low to high do
      begin
        m_mesh.Interpolate_nn(i * int, j * int, k * int);
        inc(n);
      end;
    end;
  end;
  ShowMessage('done. ' + IntToStr(n));
end;


//******************************************************************************
// Description: Testing the delete_ear function. Starting from a dataset, a grid
//              of points are inserted and then immediatly deleted with the
//              EAR method
//
// Input:       -
//
// Output:      the test is performed, if nothing went wrong it says 'done.'
//******************************************************************************
procedure TForm1.TestingInsertDeleteGridEarMenuClick(Sender: TObject);
var
  i, j, k: integer;
  min, max: double;
  interval: integer;
  spacing: double;
  lstPts: TList;
  tempt: TPoint;
  n: integer;
  stop: boolean;
begin
//  min := 0.04;
//  max := 0.93;
  min := 0.35;
  max := 0.65;
  interval := 7;
  spacing := (max - min) / interval;

  ProgressBar1.Min := 0;
  ProgressBar1.Max := (interval + 1) * (interval + 1) * (interval + 1);
  ProgressBar1.Step := 1;
  n := 0;
  lstPts := m_mesh.GetListPts;
  stop := false;
  for i := 0 to interval do
  begin
    for j := 0 to interval do
    begin
      for k := 0 to interval do
      begin
//        if (n <> 188) then
//        begin
          try
            m_mesh.InsertPoint(min + (i * spacing), min + (j * spacing), min + (k * spacing));
            tempt := lstPts.Last;
//            m_mesh.DeleteVertex_power__2(tempt);
            m_mesh.DeleteVertex_insphere(tempt);
          except
            on E: Exception do
          end;
{        end
        else
        begin
          m_mesh.InsertPoint(min + (i * spacing), min + (j * spacing), min + (k * spacing));
          tempt := lstPts.Last;
          ShowMessage(floattostr(tempt.x) + '   ' + floattostr(tempt.y)  + '   ' +  floattostr(tempt.z));
          stop := true;
          break;
        end;
}
//        if (n > 30) then
//          ShowMessage(inttostr(n));

//        if (n > 180) then
//          ShowMessage(inttostr(n));
          //ShowMessage(floattostr(tempt.x) + ' ' + floattostr(tempt.y) + ' ' + floattostr(tempt.z));

        inc(n);
        ProgressBar1.StepIt;
        ProgressBar2.StepIt;
      end;
      if (stop = true) then
        break;
    end;
    if (stop = true) then
      break;
  end;
  m_mesh.BuildDisplayList;
  ProgressBar1.Position := 0;
  ProgressBar2.Position := 0;
  ShowMessage('done. ' + IntToStr(n));
end;


//******************************************************************************
// Description: Testing the delete_power function. Starting from a dataset, a
//              grid of points are inserted and then immediatly deleted with the
//              POWER method.
//
// Input:       -
//
// Output:      the test is performed, if nothing went wrong it says 'done.'
//******************************************************************************
procedure TForm1.TestingInsertDeleteGridPowerMenuClick(Sender: TObject);
var
  i, j, k: integer;
  lstPts: TList;
  tempt: TPoint;
  n: integer;
begin
  n := 0;
  lstPts := m_mesh.GetListPts;
  for i := 0 to 5 do
  begin
    for j := 0 to 5 do
    begin
      for k := 0 to 5 do
      begin
        m_mesh.InsertPoint(i * 0.2, j * 0.2, k * 0.2);
        tempt := lstPts.Last;
        m_mesh.DeleteVertex_power(tempt);
        inc(n);
      end;
    end;
  end;
  ShowMessage('done. ' + IntToStr(n));
end;


procedure TForm1.TestingDeleteInsertAllMenuClick(Sender: TObject);
var
  lstPts: TList;
  i, j: integer;
  tempt: TPoint;
  x, y, z, data: double;
  n: integer;
begin
  lstPts := m_mesh.GetListPts;
  n := lstPts.Count - 4;
  ProgressBar1.Min := 0;
  ProgressBar1.Max := n;
  ProgressBar1.Step := 1;
  ProgressBar1.Position := 0;
  j := 0;
  for i := 4 to (lstPts.Count - 1) do
  begin
    tempt := lstPts[4];
    x := tempt.x;
    y := tempt.y;
    z := tempt.z;
    data := tempt.data;
//    if (n = 124) then  // 21 -- 175
//      break;
{    if (n = 24) then
    begin
      m_mesh.DeleteVertex_ear__2(tempt, true);
      m_mesh.InsertPoint(x, y, z, data);
      inc(j);
      ProgressBar1.StepIt;
      ProgressBar2.StepIt;
      ShowMessage(floattostr(x) + '   ' + floattostr(y) + '   ' +  floattostr(z));
      break;
    end;
}    data := tempt.data;
    m_mesh.DeleteVertex_insphere(tempt);
//    m_mesh.DeleteVertex_power__2(tempt);
    m_mesh.InsertPoint(x, y, z, data);
    inc(j);
    ProgressBar1.StepIt;
    ProgressBar2.StepIt;
//    if (n < 130) then
//      ShowMessage(IntToStr(n));
    dec(n);
  end;
  ProgressBar1.Position := 0;
  ShowMessage('done. # of points deleted/inserted : ' + IntToStr(j));
end;


function TForm1.StampTime: double;
var
  dt: TDateTime;
  ts: TTimeStamp;
begin
  dt := Time;
  ts := DateTimeToTimeStamp(dt);
  Result := (ts.Time) / 1000; //-- get the time in sec.
end;


procedure TForm1.TestingDeleteAllRandomly_insphereMenuClick(Sender: TObject);
var
  lstPts: TList;
  n, i: integer;
  pt: TPoint;
  startTime, endTime: double;
begin
  lstPts := m_mesh.GetListPts;
  n := lstPts.Count;
  startTime := self.StampTime;
{  while (n > 4) do
  begin
    i := Floor(Random * (n - 4) + 4);
    m_mesh.DeleteVertex_insphere(lstPts[i]);
    n := lstPts.Count;
  end;
}
  while (n > 4) do
  begin
    m_mesh.DeleteVertex_insphere(lstPts.Last);
    n := lstPts.Count;
//    if (n = 39) then
//    begin
//    break;
//      m_mesh.DeleteVertex_insphere(lstPts.Last);
 //     if (n mod 10 = 0) then
//        ShowMessage('points left:  ' + IntToStr(n));
//    end;
  end;
  endTime := self.StampTime;
  ShowMessage('total time = ' + FloatToStr(endTime - startTime));
  ShowMessage('Orient = ' + IntToStr(TGeomTools.GetCountCallOrient));
  ShowMessage('InSphere = ' + IntToStr(TGeomTools.GetCountCallInSphere));
  m_mesh.BuildDisplayList;
  FormPaint(self);
end;


procedure TForm1.TestingDeleteAllRandomly_powerMenuClick(Sender: TObject);
var
  lstPts: TList;
  n, i: integer;
  pt: TPoint;
  startTime, endTime, wastedTime, tempTime: double;
begin
  TGeomTools.SetCountCallToZero;
  lstPts := m_mesh.GetListPts;
  Randomize;
  n := lstPts.Count;
  wastedTime := 0;
  startTime := self.StampTime;
  while (n > 4) do
  begin
    i := Floor(Random * (n - 4) + 4);
    tempTime := m_mesh.DeleteVertex_power__clean(lstPts[i]);
    n := lstPts.Count;
    wastedTime := wastedTime + tempTime;
  end;
{  while (n > 4) do
  begin
    m_mesh.DeleteVertex_power__clean(lstPts.Last);
    n := lstPts.Count;
  end; }
  endTime := self.StampTime;
  ShowMessage('total time = ' + FloatToStr(endTime - startTime));
  ShowMessage('wasted time = ' + FloatToStr(wastedTime));
  ShowMessage('Orient = ' + IntToStr(TGeomTools.GetCountCallOrient));
  ShowMessage('InSphere = ' + IntToStr(TGeomTools.GetCountCallInSphere));
  m_mesh.BuildDisplayList;
  FormPaint(self);
end;



procedure TForm1.TestingDeleteAllRandomlyDLimitMenuClick(Sender: TObject);
var
  lstPts: TList;
  n, i, j: integer;
  times: array[5..27] of double;
  dlimit: integer;
  pt: TPoint;
  startTime, endTime, tempTime: double;
  fi, fo: TextFile;
  io: TMesh_IO;
begin
  for i := 5 to 27 do
  begin
    AssignFile(fi, 'd:\points\rand_2000.pts');
    Reset(fi);
    try
      io := TMesh_IO.Create(m_mesh);
      io.ReadPoints(fi);
      io.Free;
//      m_mesh.BuildDisplayList;
    finally
      CloseFile(fi);
    end;

    dlimit := i;
    lstPts := m_mesh.GetListPts;
    n := lstPts.Count;
    startTime := self.StampTime;
    while (n > 4) do
    begin
      j := Floor(Random * (n - 4) + 4);
      m_mesh.DeleteVertex_optimal(lstPts[j], dlimit);
//      m_mesh.DeleteVertex_optimal(lstPts.Last, dlimit);
      n := lstPts.Count;
    end;
    endTime := self.StampTime;
    times[i] := endTime - startTime;
  end;

  AssignFile(fo, 'd:\Tetra Robust\results.txt');
  Rewrite(fo);
  for i := 5 to 27 do
  begin
    Write(fo, IntToStr(i) + #9);
    WriteLn(fo, FloatToStrF(times[i], fffixed, 15, 15));
  end;
  CloseFile(fo);

  m_mesh.BuildDisplayList;
  FormPaint(self);
  ShowMessage('done.');
end;


procedure TForm1.TestingDeleteInsertPointClick(Sender: TObject);
var
  numNN: integer;
  lstPts: TList;
  i: integer;
  pt: TPoint;
  tempt: TPoint;
  startTime, endTime: double;
begin
  numNN := 7;
  tempt := TPoint.Create;
  lstPts := m_mesh.GetListPts;
  for i := 4 to (lstPts.Count - 1) do
  begin
    pt := lstPts[i];
    if (m_mesh.GetDegree(pt) = numNN) then
    begin
      tempt.CopyValue(pt);
      startTime := self.StampTime;
      TGeomTools.SetCountCallToZero;
      m_mesh.DeleteVertex_insphere(pt);
      endTime := self.StampTime;
      ShowMessage('total time = ' + FloatToStr(endTime - startTime));
      ShowMessage('Orient = ' + IntToStr(TGeomTools.GetCountCallOrient));
      ShowMessage('InSphere = ' + IntToStr(TGeomTools.GetCountCallInSphere));
      m_mesh.InsertPoint(tempt.x, tempt.y, tempt.z);
      break;
    end;
  end;
end;


procedure TForm1.TestingDeleteNNMenuClick(Sender: TObject);
var
  degree: integer;
  noOps: array[5..33] of integer;
  times: array[5..33] of double;
  lstPts: TList;
  i, j: integer;
  pt: TPoint;
  tempt: TPoint;
  startTime, endTime: double;
  ff: TextFile;
begin
  tempt := TPoint.Create;
  lstPts := m_mesh.GetListPts;
  for i := 5 to 33 do
  begin
    for j := 4 to (lstPts.Count - 1) do
    begin
      pt := lstPts[j];
      if (m_mesh.GetDegree(pt) = i) then
      begin
        tempt.CopyValue(pt);
        TGeomTools.SetCountCallToZero;
        startTime := self.StampTime;
//        m_mesh.DeleteVertex_insphere(pt);
        m_mesh.DeleteVertex_power__clean(pt);
        endTime := self.StampTime;
        times[i] := endTime - startTime;
        noOps[i] := TGeomTools.GetCountCallInSphere;
        m_mesh.InsertPoint(tempt.x, tempt.y, tempt.z);
        break;
      end;
    end;
  end;
  AssignFile(ff, 'd:\Tetra Robust\results.txt');
  Rewrite(ff);
  for i := 5 to 33 do
  begin
    Write(ff, IntToStr(i) + #9);
    WriteLn(ff, IntToStr(noOps[i]) + #9 + FloatToStrF(times[i], fffixed, 15, 15));
  end;
  CloseFile(ff);
  ShowMessage('done.');
end;


procedure TForm1.MiscMinMaxDegreeMenuClick(Sender: TObject);
var
  i: integer;
  lstPts: TList;
  min, max, deg: integer;
begin
  min := 999;
  max := 0;
  lstPts := m_mesh.GetListPts;
  for i := 4 to (lstPts.Count - 1) do
  begin
    deg := m_mesh.GetDegree(lstPts[i]);
    if (deg < min) then
      min := deg;
    if (deg > max) then
      max := deg;
  end;
  ShowMessage('min: ' + IntToStr(min) + #9 + 'max: ' + IntToStr(max));
end;


procedure TForm1.Edit8Change(Sender: TObject);
begin
  self.Label11.Caption := 'X  ' + self.Edit8.Text;
end;



procedure TForm1.CheckBox12Click(Sender: TObject);
var
  estimates: array of double;
  gridSize: integer;
  zPos: double;
  method: integer;
  radius: double;
begin
  if (CheckBox12.Checked = true) then
  begin
    gridSize := StrToInt(self.Edit8.Text);
    zPos := StrToFloat(self.Edit9.Text);
    radius := 0.0;
    method := 1;
    if (self.RadioButton1.Checked = true) then //-- linear interpol
      method := 1
    else if (self.RadioButton2.Checked = true) then //-- nn interpol
      method := 2
    else if (self.RadioButton3.Checked = true) then //-- IDW interpol
    begin
      method := 3;
      radius := StrToFloat(Edit10.Text);
    end;
    SetLength(estimates, gridSize * gridSize);
    m_mesh.SliceInterpolation(method, gridSize, zPos, estimates, radius);

//-- draw the slice on the screen
    m_mesh.bDrawInterpol := true;
    m_mesh.DrawSliceInterpolationStartEnd(true);
    m_mesh.DrawSliceInterpolation(estimates, gridSize, zPos);
    m_mesh.DrawSliceInterpolationStartEnd(false);
  end
  else
  begin
    m_mesh.bDrawInterpol := false;
  end;
  FormPaint(self);
end;


procedure TForm1.Edit9Exit(Sender: TObject);
var
  value: double;
begin
  value := StrToFloat(self.Edit9.Text);
  if (value > 1.0) then
    Edit9.Text := '1.0';
  if (value < 0.0) then
    Edit9.Text := '0';
end;


procedure TForm1.TestingInterpolateInsertMenuClick(Sender: TObject);
begin
  TestInterpolationNN(0);
end;


procedure TForm1.Button6Click(Sender: TObject);
var
  name: string;
  f: TextFile;
  io: TMesh_IO;
begin
  AssignFile(f, 'd:\points\zzz.pts');
  Reset(f);
  try
    io := TMesh_IO.Create(m_mesh);
    io.ReadPoints(f);
    io.Free;
    m_mesh.BuildDisplayList;
  finally
    CloseFile(f);
  end;
  FormPaint(self);
 end;


procedure TForm1.TestInterpolationNN(step: integer);
var
  nb: integer;
  att: integer;
  i, j: integer;
  coord: array[0..3] of double;
  temp: double;
  startTime, endTime: double;
  f: TextFile;
begin
  AssignFile(f, 'd:\points\nni\1000c.pts');
  Reset(f);
  read(f, att);
  read(f, nb);
  startTime := self.StampTime;
  try
    for i := 1 to nb do
    begin
      for j := 0 to 3 do
      begin
        read(f, temp);
        coord[j] := temp;
      end;
      if (step = 1) then
        m_mesh.InsertDelete(coord[0], coord[1], coord[2]);
      if (step = 2) then
        m_mesh.Interpolate_nn(coord[0], coord[1], coord[2]);
      m_mesh.InsertPoint(coord[0], coord[1], coord[2], coord[3]);
    end;
    endTime := self.StampTime;
    ShowMessage('total time = ' + FloatToStr(endTime - startTime));
//    m_mesh.BuildDisplayList;
  finally
    CloseFile(f);
  end;
//  FormPaint(self);
end;


procedure TForm1.Button7Click(Sender: TObject);
var
  lstPts: TList;
begin
  lstPts := m_mesh.GetListPts;
  m_mesh.MovePointTo(lstPts[9], 0.5, 0.5, 0.5);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  TestInterpolationNN(1);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  TestInterpolationNN(2);
end;

procedure TForm1.MenuInsertRandomCubeClick(Sender: TObject);
const
  min: double = 0.4;
  max: double = 0.6;
var
  nb: integer;
  i: integer;
  plane: integer;
  r1, r2: double;
  startTime, endTime: double;
begin
  RandomFrm.Form2.Caption := 'Random points on a cube';
  if (RandomFrm.Form2.ShowModal = mrOk) then
  begin
    nb := StrToInt(RandomFrm.Form2.Edit1.Text);
    ProgressBar1.Min := 0;
    ProgressBar1.Max := nb;
    ProgressBar1.Step := 1;
    Randomize;
    startTime := self.StampTime;
    for i := 1 to nb do
    begin
      r1 := (Random * (max - min)) + min;
      r2 := (Random * (max - min)) + min;
      plane := Floor((Random * 6) + 1); //-- value [1..6], for each face of cube

      case plane of
        1: m_mesh.InsertPoint(min, r1, r2, Random * 5);
        2: m_mesh.InsertPoint(max, r1, r2, Random * 5);
        3: m_mesh.InsertPoint(r1, min, r2, Random * 5);
        4: m_mesh.InsertPoint(r1, max, r2, Random * 5);
        5: m_mesh.InsertPoint(r1, r2, min, Random * 5);
        6: m_mesh.InsertPoint(r1, r2, max, Random * 5);
      end;
      ProgressBar1.StepIt;
    end;
    endTime := self.StampTime;
    ShowMessage('total time = ' + FloatToStr(endTime - startTime));
  end;
  m_mesh.BuildDisplayList;
  FormPaint(self);
  ProgressBar1.Position := 0;
end;




procedure TForm1.MiscNbPtsCHClick(Sender: TObject);
begin
  ShowMessage(IntToStr(m_mesh.GetNbPtsOnCH));
end;


procedure TForm1.MiscVolumeRatioClick(Sender: TObject);
var
  i: integer;
  lstPts: TList;
  volume0, volume1: double;
  vol: double;
  tempt: TPoint;
begin
  volume0 := 0;
  volume1 := 0;
  lstPts := m_mesh.GetListPts;
  for i := 4 to (lstPts.Count - 1) do
  begin
    tempt := lstPts[i];
    if (m_mesh.IsBoundaryCH(tempt) = false) then
    begin
      vol := m_mesh.GetVolumeVoronoiCell(tempt);
      if (Floor(tempt.data) mod 2 = 0) then //-- phase 0
        volume0 := volume0 + vol
      else //-- phase 1
        volume1 := volume1 + vol;
    end;
  end;
  ShowMessage('phase 0: ' + FloatToStr(volume0) + #9 + 'phase 1: ' + FloatToStr(volume1)
              + #9 + 'ratio 0/1: ' + FloatToSTr(volume0/volume1));
end;



procedure TForm1.CheckBox15Click(Sender: TObject);
var
  estimates: array of double;
  gridSize: integer;
  zPos: double;
  i: integer;
  value: double;
  colour: integer;
  nbSlices: integer;
  slices: array[1..9] of boolean;
  bDrawPoints: boolean;
  lstPts: TList;
begin
  if (CheckBox15.Checked = true) then
  begin
//-- check which slices are wanted
    nbSlices := 0;
    for i := 1 to 9 do
    begin
      if (CheckListBox1.Checked[i-1] = true) then
      begin
        inc(nbSlices);
        slices[i] := true;
      end
      else
      begin
        slices[i] := false;
      end;
    end;

    if (nbSlices = 0) then
    begin
      ShowMessage('No slices are selected');
    end
    else
    begin
      bDrawPoints := CheckBox17.Checked;
      m_mesh.bDrawInterpol := true;
      if ( (CheckBox17.Checked = true) and (nbSlices > 1) ) then
      begin
        CheckBox17.Checked := false;
        bDrawPoints := false;
        ShowMessage('Data points can only be highlighted when 1 slice is drawn');
      end;

      m_mesh.bDrawSlicePts := bDrawPoints;
      //-- draw slices for each different zPos
      gridSize := 250;
      m_mesh.DrawSliceInterpolationStartEnd(true);
        for i := 1 to 9 do
        begin
          if (slices[i] = true) then
          begin
            zPos := i / 10;
            SetLength(estimates, gridSize * gridSize);
            m_mesh.SliceInterpolation(4, gridSize, zPos, estimates, 0.0);
            m_mesh.DrawSliceInterpolation(estimates, gridSize, zPos);
          end;
        end;
      m_mesh.DrawSliceInterpolationStartEnd(false);
      if (bDrawPoints = true) then
      begin
        m_mesh.SetSlicePts(self.CheckBox14.Checked);
      end;
    end;
  end
  else
  begin
    m_mesh.bDrawInterpol := false;
    m_mesh.bDrawSlicePts := false;
    m_mesh.ResetFlagAllPts;
  end;
  FormPaint(self);
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
  ShowMessage('Coming soon...');
end;


procedure TForm1.CheckBox16Click(Sender: TObject);
var
  pt, pt2: TPoint;
  i: integer;
begin
  if (CheckBox16.Checked = true) then
  begin
    i := ComboBox1.ItemIndex;
    if (i <> -1) then
    begin
      m_mesh.bDrawMovingPt := true;
      pt := TPoint(ComboBox1.Items.Objects[i]);
      pt2 := TPoint.Create(StrToFloat(Edit14.Text),
                           StrToFloat(Edit15.Text),
                           StrToFloat(Edit16.Text));
      m_mesh.SetMovingPt(pt, pt2);
      pt2.Free;
      Button10.Enabled := true;
//      CheckBox16.Checked := false;
      self.Refresh;
    end
    else
    begin
      ShowMessage('You must first select a vertex.');
      CheckBox16.Checked := false;
    end;
  end
  else
  begin
    m_mesh.bDrawMovingPt := false;
    Button10.Enabled := false;
    FormPaint(self);
  end;
end;


procedure TForm1.Button10Click(Sender: TObject);
var
  i: integer;
  pt: TPoint;
begin
  i := ComboBox1.ItemIndex;
  if (i <> -1) then
  begin
    pt := TPoint(ComboBox1.Items.Objects[i]);
    m_mesh.MovePointTo(pt, StrToFloat(Edit14.Text),
                           StrToFloat(Edit15.Text),
                           StrToFloat(Edit16.Text));
    FormPaint(self);
  end
  else
  begin
    ShowMessage('You must first select a vertex.');
  end;
end;


procedure TForm1.Button11Click(Sender: TObject);
begin
  Randomize;
  Edit14.Text := FloatToStrF(Random, ffGeneral, 5, 1);
  Edit15.Text := FloatToStrF(Random, ffGeneral, 5, 1);
  Edit16.Text := FloatToStrF(Random, ffGeneral, 5, 1);
  CheckBox16Click(nil);
end;


procedure TForm1.Button12Click(Sender: TObject);
var
  i: integer;
  pt: TPoint;
begin
  Randomize;
  i := ComboBox1.ItemIndex;
  if (i <> -1) then
  begin
    pt := TPoint(ComboBox1.Items.Objects[i]);
    while true do
    begin
      m_mesh.MovePointTo(pt, Random, Random, Random);
    end;
  end;
end;


procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  ComboBox1Select(nil);
end;



procedure TForm1.CheckBox13Click(Sender: TObject);
begin
  ComboBox1Select(nil);
end;

procedure TForm1.CheckBox18Click(Sender: TObject);
var
  i: integer;
  pt: TPoint;
begin
  if (CheckBox18.Checked = true) then
  begin
    i := ComboBox1.ItemIndex;
    if (i <> -1) then
    begin
      pt := TPoint(ComboBox1.Items.Objects[i]);
      m_mesh.SetHLCell(pt);
      GLScene.getManipulator.SetRotationCenter(pt.x, pt.y, pt.z);
      m_mesh.bDrawHLCell := true;
      FormPaint(self);
    end
    else
    begin
      ShowMessage('You must first select a vertex.');
      CheckBox18.Checked := false;
    end;
  end
  else
  begin
    m_mesh.bDrawHLCell := false;
    FormPaint(self);
  end;
end;


procedure TForm1.MiscVolumeVoronoiCellClick(Sender: TObject);
var
  i: integer;
  pt: TPoint;
  vol: double;
begin
  i := ComboBox1.ItemIndex;
  if (i <> -1) then
  begin
    pt := TPoint(ComboBox1.Items.Objects[i]);
    vol := m_mesh.GetVolumeVoronoiCell(pt);
    ShowMessage('volume of Voronoi cell is:  ' + FloatToStr(vol));
  end
  else
  begin
    ShowMessage('You must first select a vertex.');
  end
end;

procedure TForm1.MiscIsOnCHClick(Sender: TObject);
var
  i: integer;
  re: boolean;
begin
  i := ComboBox1.ItemIndex;
  if (i <> -1) then
  begin
    re := m_mesh.IsBoundaryCH(TPoint(ComboBox1.Items.Objects[i]));
    if (re = true) then
      ShowMessage('YES on the convex hull')
    else
      ShowMessage('NOT on the convex hull');
  end
  else
  begin
    ShowMessage('You must first select a vertex.');
  end;
end;


procedure TForm1.TestingDelete10percentClick(Sender: TObject);
var
  lstPts: TList;
  n, i: integer;
  pt: TPoint;
  startTime, endTime: double;
begin
  lstPts := m_mesh.GetListPts;
  startTime := self.StampTime;
  for i := 1 to 100 do
  begin
    m_mesh.DeleteVertex_insphere(lstPts.Last);
  end;
  endTime := self.StampTime;
  ShowMessage('total time = ' + FloatToStr(endTime - startTime));
  ShowMessage('Orient = ' + IntToStr(TGeomTools.GetCountCallOrient));
  ShowMessage('InSphere = ' + IntToStr(TGeomTools.GetCountCallInSphere));
  m_mesh.BuildDisplayList;
  FormPaint(self);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  self.MiscVolumeVoronoiCellClick(nil);
end;

end.
